from xml.etree import ElementTree
from eulxml import xpath
import codecs

def convertnode(entry, parentsymbolicname = ""):
	global file
	for child in entry.findall("ObjectMapEntry"):
		symbolicname = child.get("id")
		if len(symbolicname) < 1:
			continue
		xpathstring = child.get("locator")
		ast = xpath.parse(xpathstring)
		predlist = []
		pymapstring=""
		try:
			if len(ast.relative.predicates[0]) == 1:
				continue
			if ast.relative.predicates[1] > 0:
				continue
		except:
			pass

		try:
			for predicate in ast.relative.right.predicates:
				if predicate.left.node_test.name == 'automationId':
					predicate.left.node_test.name = 'id'
				elif predicate.left.node_test.name == 'className':
					predicate.left.node_test.name = 'class'
				predlist.append("'{}':'{}'".format(predicate.left.node_test.name, predicate.right))
		except:
			if not hasattr(ast.relative, 'predicates'):
					continue
			for predicate in ast.relative.predicates:
				if type(predicate) is int:
					continue
				try:
					if predicate.left.node_test.name == 'automationId':
						predicate.left.node_test.name = 'id'
					elif predicate.left.node_test.name == 'className':
						predicate.left.node_test.name = 'class'
					predlist.append("'{}':'{}'".format(predicate.left.node_test.name, predicate.right))
				except:
					pass
		if len(predlist) > 0:
			if len(parentsymbolicname) > 0:
				predlist.append("'container':{}".format(parentsymbolicname))
			pymapstring = "{" + ", ".join(predlist) + "}"
			file.write("{} = {} \n".format(symbolicname, pymapstring))
			print ("{} = {}").format(symbolicname, pymapstring)
		convertnode(child, symbolicname)




if __name__=="__main__":
	file = codecs.open('names.py', 'w')
	xmlfile = "silktestmap.xml"
	tree = ElementTree.parse(xmlfile)
	root = tree.getroot()
	convertnode(root)
	file.close()

